"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.scoped = void 0;
const scoped_private_js_1 = require("./scoped.private.js");
const logWarnings = process.env.NODE_ENV !== 'production';
/**
 * Returns a randomized/unique string token, with an optional `prefix`. These
 * tokens can be using for naming `@keyframes` or for mangled class-names, if
 * that's what you need:
 *
 * @see https://github.com/maranomynet/es-in-css/tree/v0.7#scoped-name-generator
 */
/*#__NO_SIDE_EFFECTS__*/
const scoped = (prefix) => (0, scoped_private_js_1._scoped)(prefix, logWarnings);
exports.scoped = scoped;
