"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makePrettifyCSS = void 0;
const prettier_1 = __importDefault(require("prettier"));
const makePrettifyCSS = (cliArg, outdir) => {
    const cfgPath = typeof cliArg === 'string' ? cliArg : undefined;
    const basePath = `${(outdir || '.').replace(/\/$/, '')}/file.css`;
    const configResolver = prettier_1.default
        .resolveConfig(basePath, {
        config: cfgPath,
        editorconfig: true,
        // useCache: false,
    })
        .then((config) => Object.assign({}, config, { parser: 'css' }));
    return (css) => configResolver.then((config) => prettier_1.default.format(css, config));
};
exports.makePrettifyCSS = makePrettifyCSS;
